#!/bin/bash
#getpwpolicies.sh
#
# Copyright © [2008] Novell, Inc.  All Rights Reserved.
#
# USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE DEVELOPER LICENSE
# AGREEMENT OR OTHER AGREEMENT THROUGH WHICH NOVELL, INC. MAKES THE WORK
# AVAILABLE. THIS WORK MAY NOT BE ADAPTED WITHOUT  NOVELL'S PRIOR WRITTEN
# CONSENT.
#
# NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
# INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY,FITNESS FOR
# A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  NOVELL, THE AUTHORS OF THE
# WORK, AND THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY
# CLAIM, DAMAGES, OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT, OR OTHERWISE, ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK
# OR THE USE OR OTHER DEALINGS IN THE WORK.
#
# All rights reserved.
#
# Author: Prem Tamang feedback to tprem@novell.com
# Author: Balaji Swaminathan feedback to sbalaji@novell.com
#

if test $# == 2
then
	username=$1
	password=$2
	LDAP_SEARCH_BIN=env LDAPTLS_CACERT=/etc/opt/novell/certs/SSCert.pem /usr/bin/ldapsearch
	LDAP_SEARCH_OUT=`env LDAPTLS_CACERT=/etc/opt/novell/certs/SSCert.pem $LDAP_SEARCH_BIN -D "$username" -w "$password" -H ldaps://"$hostname":$port -LLL -s sub objectclass=nspmPasswordPolicy 1.1`

	if test `echo $?` -eq 0
	then
		echo $LDAP_SEARCH_OUT |  sed 's/[[:space:]]\+dn:[[:space:]]/#/g'  | sed 's/[[:space:]]*dn:[[:space:]]//g'
	else
		echo ""
	fi
elif test $# == 5
then
	username=$1
	password=$2
	hostname=$3
	port=$4
	isSslEnabled=$5

	user_id=`id -u`
	if test $user_id -ne 0
	then
        	echo "getpwpolicies.sh : Only root user can run this script"
	        exit 1
	fi

	LDAP_SEARCH_BIN=env LDAPTLS_CACERT=/etc/opt/novell/certs/SSCert.pem /usr/bin/ldapsearch
	if [ $isSslEnabled == 1 ]
	then
		LDAP_SEARCH_OUT=`$LDAP_SEARCH_BIN -D "$1" -w $2 -H ldaps://"$3":$4 -LLL -s sub objectclass=nspmPasswordPolicy 1.1  |  sed -e :z -e 'N;s/\n[[:space:]]\(.*\)/\1/;tz' -e 'P;D'`
	else
		LDAP_SEARCH_OUT=`$LDAP_SEARCH_BIN -D "$1" -w $2 -H ldap://"$3":$4 -LLL -s sub objectclass=nspmPasswordPolicy 1.1  |  sed -e :z -e 'N;s/\n[[:space:]]\(.*\)/\1/;tz' -e 'P;D'`
	fi
	if test `echo $?` -eq 0
	then
		if [ -n "$LDAP_SEARCH_OUT" ]
		then
			echo $LDAP_SEARCH_OUT |  sed 's/[[:space:]]\+dn:[[:space:]]/\n/g'  | sed 's/[[:space:]]*dn:[[:space:]]//g'
		else
			exit 2
		fi
	else
	exit 2
	fi
else
    echo "Usage: getpwpolicies.sh <adminFDN> <adminPassword> <hostname> <port> <isSslEnabled>"
fi

